;============================================================================;
;                                  move.asm                                  ;

;============================================================================;
;move                                                                        ;
;    Input     : d6.w = key value (up or down)                               ;
;    Output    : graphics                                                    ;
;    Destroyed : d0-d5/a0                                                    ;

move\down
         move.w     number_to_draw(pc),d0
         cmp.w      cursor(pc),d0
         bne.s      move\down\not_bottom
         move.w     number(pc),d1
         cmp.w      current(pc),d1
         beq        move\go_to_top\test_shift
         moveq.w    #draw\y+draw\height-8,d5
         moveq.w    #1,d7
         bra        move\scroll

move\down\not_bottom
         bsr        invert
         addq.w     #1,cursor
         bsr        invert
         addq.w     #1,current
         bsr        selection\test_shift
         bra        draw_split_window

move\down\second
         move.w     current(pc),d5             ; d5 = current\folder
         add.w      #number_drawed+1,d5        ; d5 = current\folder + 10
         cmp.w      number(pc),d5
         bcc.s      move\go_to_bottom          ; number_folders <= d5
         move.w     cursor(pc),d0
         add.w      number(pc),d0              ; d0 = cursor + number_folders
         sub.w      #number_drawed+1,d0        ; d0 = d0 - 10
         cmp.w      d0,d5
         bls.s      move\down\not_last_page    ; d0 > d5
         move.w     d5,d1                      ; d1 = current\folder + 10
         move.w     number(pc),d5
         sub.w      #number_drawed,d5          ; d5 = number_folders - 10
         sub.w      d5,d1                      ; d1 = current\folder + 20
         move.w     d1,cursor                  ; d1 = new cursor
         bsr        move_to
         bra        invert
move\down\not_last_page
         sub.w      cursor(pc),d5
         bsr        move_to
         bra        invert

move\go_to_bottom\test_shift
         btst.b     #select_bit,old_indicators(pc)
         beq.s      move\go_to_bottom\exit

move\go_to_bottom
         move.w     number(pc),d5
         cmp.w      current(pc),d5
         beq.s      move\go_to_bottom\exit
         move.w     d5,d0
         sub.w      number_to_draw(pc),d0
         add.w      cursor(pc),d0
         cmp.w      current(pc),d0
         bne.s      move\go_to_bottom\many_pages
         bsr        invert
         move.w     d5,current
         move.w     number_to_draw(pc),cursor  ; cursor at bottom
         bsr        draw_split_window
         bra.s      move\go_to_bottom\end
move\go_to_bottom\many_pages
         sub.w      number_to_draw(pc),d5
         move.w     number_to_draw(pc),cursor  ; cursor at bottom
         bsr        move_to
move\go_to_bottom\end
         bra        invert
move\go_to_bottom\exit
         rts

move\up
         tst.w      cursor
         bne.s      move\up\not_top
         tst.w      current
         beq.s      move\go_to_bottom\test_shift
         moveq.w    #draw\y,d5
         moveq.w    #-1,d7
         bra        move\scroll

move\up\not_top
         bsr        invert
         subq.w     #1,cursor
         bsr        invert
         subq.w     #1,current
         bsr        selection\test_shift
         bra        draw_split_window

move\up\second
         move.w     current(pc),d5
         sub.w      #number_drawed+1,d5         ; d5 = current\folder - 10
;         tst.w      d5                          ; not needed !
         bmi.s      move\go_to_top              ; d5 < 0
         cmp.w      cursor(pc),d5
         bls.s      move\up\first_page
         sub.w      cursor(pc),d5
         bsr        move_to
         bra        invert
move\up\first_page
         move.w     d5,cursor
         clr.w      d5
         bsr        move_to
         bra        invert

move\go_to_top\test_shift
         btst.b     #select_bit,old_indicators(pc)
         beq.s      move\go_to_top\exit

move\go_to_top
         move.w     current(pc),d0
         tst.w      d0
         beq.s      move\go_to_top\exit
         cmp.w      cursor(pc),d0
         bne.s      move\go_to_top\not_in_first_page
         bsr        invert
         clr.w      current
         clr.w      cursor
         bsr        draw_split_window
         bra.s      move\go_to_top\end
move\go_to_top\not_in_first_page
         clr.w      cursor                  ; cursor at top
         clr.w      d5
         bsr        move_to
move\go_to_top\end
         bra        invert
move\go_to_top\exit
         rts

;============================================================================;
;move\a_to_z                                                                 ;
;    Input     : d6 = a - z                                                  ;
;    Output    : void                                                        ;
;    Destroyed : d0,d1,d2,d3,d4,d5,a0,a5                                     ;

move\a_to_z
         move.w     current(pc),d3
         move.w     number(pc),d2
         subq.b     #1,d2

move\a_to_z\loop
         addq.w     #1,d3
         cmp.w      number(pc),d3  ;
         sls.w      d0             ;  d3 modulo number
         and.w      d0,d3          ;
         move.w     d3,d1
         bsr        get_handle
         cmp.b      (a2),d6
         dbeq.s     d2,move\a_to_z\loop

         cmp.w      #-1,d2
         beq.s      move\a_to_z\exit

         move.w     current(pc),d0
         sub.w      cursor(pc),d0
         move.w     number_to_draw(pc),d1
         cmp.w      d0,d3
         bcs.s      move\a_to_z\go_to\not_in_current_page
         add.w      d0,d1
         cmp.w      d1,d3
         bhi.s      move\a_to_z\go_to\not_in_current_page
         move.w     d3,current
         move.w     d3,d5
         sub.w      d0,d5
         bsr        invert
         move.w     d5,cursor
         bsr        invert
         bra        draw_split_window

move\a_to_z\go_to\not_in_current_page
         cmp.w      d3,d1
         bcc.s      move\a_to_z\go_to\in_first_page

move\a_to_z\go_to\not_in_first_page
         move.w     d3,d5
         sub.w      #number_drawed,d5
         move.w     #number_drawed,cursor
         bra.s      move\a_to_z\exit\move_to

move\a_to_z\go_to\in_first_page
         clr.w      d5
         move.w     d3,cursor

move\a_to_z\exit\move_to
         bsr        move_to
         bra        invert

move\a_to_z\exit
         rts

;============================================================================;
;move_to                                                                     ;
;    Input     : d5.w = index of first variable showed (zeroed)              ;
;    Output    : graphics                                                    ;
;    Destroyed : d0-d5/a5                                                    ;

move_to\current
         move.w     current(pc),d5
         sub.w      cursor(pc),d5
move_to
         move.w     d5,current
         move.w     cursor(pc),d0
         add.w      d0,current
         bsr        clear_window
         moveq.w    #draw\y,d4                  ; top of the window
         move.w     number_to_draw(pc),d6
         bsr        draw_name_and_details
         bra        draw_split_window

;============================================================================;
;move\scroll                                                                 ;

move\scroll
         bsr        invert
         move.w     window\name_absciss(pc),d0
         lsr.w      #3,d0
         subq.b     #1,d0                        ; d0 = X in bytes
         move.w     window\width(pc),d1
         lsr.w      #3,d1
         addq.b     #1,d1                        ; d1 = Y in bytes
         moveq.w    #(number_drawed)*8-1,d2      ; d2 = window height
         moveq.w    #30,d3
         sub.b      d1,d3

         cmp.w      #338,d6
         beq.s      move\scroll\up
move\scroll\down
         lea        LCD_MEM+(draw\y)*30,a0             ; 10th line
         bra.s      move\scroll\set
move\scroll\up
         lea        LCD_MEM+(draw\y+draw\height-9)*30,a0  ; 81th line
         add.w      d1,a0
         muls       #-1,d3
move\scroll\set
         lea        0(a0,d0.l),a0
         subq.b     #1,d1                        ; for dbra

move\scroll\line_loop
         move.w     d1,d4
move\scroll\row_loop
         cmp.w      #338,d6
         beq.s      move\scroll\row_loop\up
move\scroll\row_loop\down
         move.b     8*30(a0),(a0)+               ; 8 lines
         bra.s      move\scroll\row_loop\dbf
move\scroll\row_loop\up
         move.b     -(a0),8*30(a0)               ; 8 lines
move\scroll\row_loop\dbf
         dbf.s      d4,move\scroll\row_loop
         add.w      d3,a0
         dbf.s      d2,move\scroll\line_loop

         move.w     window\name_absciss(pc),d0
         subq.b     #6,d0
         move.w     d5,d1
         move.w     window\width(pc),d2
         moveq.w    #7,d3
         moveq.w    #1,d4
         jsr        graphlib::fill
         bsr        invert
         add.w      d7,current
         move.w     d5,-(a7)
         bsr        selection\test_shift
         move.w     (a7)+,d4
         move.w     current(pc),d5
         clr.w      d6
         bsr        draw_name_and_details\invert
         bra        draw_split_window

;=============================================================================
switch\left
         btst.b     #select_bit,old_indicators(pc)
         beq.s      switch\exit
         moveq.b    #-1,d7
         tst.b      window
         beq.s      switch\left\window_0_to_3
         cmp.b      #2,window
         bcs.s      switch\left\window_1_to_0
         bhi.s      switch\left\window_3_to_2

switch\left\window_2_to_1
         bsr        uninit_mode
         bsr        init_mode\window_0
         bsr        move_to\current
         bsr        init_mode\window_1
         bsr        invert
         bsr        switch\point_folder
         bra        draw_split_line

switch\left\window_0_to_3
         move.w     #window_0\width+9,window\name_absciss
         move.w     #window_3\width-window_0\width-1,window\width
         bsr        clear_window
         bsr        switch\window
         bra        draw_details\page

switch\exit
         rts


switch\left\window_1_to_0
switch\right\window_0_to_1
         cmp.w      #-1,number_files
         beq.s      switch\exit
         bsr        invert
         bsr        switch\window
         bsr        invert
         bra        switch\point_folder

switch\left\window_3_to_2
         cmp.w      #-1,number_files
         beq.s      switch\exit
         bsr        switch\window
         bsr        move_to\current
         bra        invert


switch\right
         btst.b     #select_bit,old_indicators(pc)
         beq.s      switch\exit
         moveq.b    #1,d7
         tst.b      window
         beq.s      switch\right\window_0_to_1
         cmp.b      #2,window
         bhi.s      switch\right\window_3_to_0

switch\right\window_1_to_2
switch\right\window_2_to_3
         bsr        switch\window
         bsr        move_to\current
         bra        invert

switch\right\window_3_to_0
         bsr        switch\window
         bsr        draw_split_window
         bra        draw_split_line

switch\window
         bsr        uninit_mode
         add.b      d7,window
         and.b      #3,window
         bra        init_mode


switch\point_folder                           ; window = 1 -> (a0) = 18 (">")
         lea        string,a0
         clr.b      1(a0)                     ; window = 0
         tst.b      window                    ;   and      -> (a0) = 32 (" ")
         beq.s      switch\unpoint_folder     ; not selected
         move.b     #18,(a0)
         bra.s      switch\point_folder\draw  ; window = 0
switch\unpoint_folder                         ;   and      -> (a0) = 15 ("-/")
         bsr        is_selected\current       ; selected
         seq.b      d0
         and.b      #17,d0
         add.b      #15,d0
         move.b     d0,(a0)
switch\point_folder\draw
         moveq.w    #window_0\name_absciss-7,d0
         moveq.w    #draw\y,d1
         move.w     cursor\folder(pc),d3
         lsl.b      #3,d3
         add.b      d3,d1
         moveq.w    #1,d3
         bra        draw_string_a0

;                                  move.asm                                  ;
;============================================================================;