;============================================================================;
;                                  tex.asm                                   ;
;============================================================================;

;ti92plus                       ; comment out to compile for the TI92+

 ifnd ti92plus
ti89
 endc

 include "globals.h"

 include "tios.h"

 include "graphlib.h"

 include "filelib.h"

 include "userlib.h"

 include "viewlib.h"

 include "ziplib.h"

 xdef _main

 xdef _exit

 xdef _comment

 ifd ti89
 xdef _ti89
 endc

 ifd ti92plus
 xdef _ti92plus
 endc

_main
         bsr        system\interrupts_off
         bsr        init\program
         bsr        wait_for_no_key

test_shell_bolt
         btst.b     #0,shell_bolt_flag(pc)
         beq.s      test_shell_bolt\end
         bsr        get_password
         beq.s      test_shell_bolt\end
         bra        _exit
test_shell_bolt\end

main_loop

         bsr        draw_info

main_loop\wait_for_a_key

         btst.b     #select_bit,old_indicators(pc)
         bne.s      main_loop\test_if_key_pressed
         bsr        selection

main_loop\test_if_key_pressed

         btst.b     #select_bit,old_indicators(pc)
         seq.b      shift_flag

         bsr        get_key
         tst.w      d6
         beq.s      main_loop\wait_for_a_key

	 pea        main_loop(pc)

main_loop\test_esc
         cmp.w      #264,d6
         beq        main_loop\exit

main_loop\test_enter
         cmp.w      #13,d6
         beq        execute

main_loop\test_up_and_down
         cmp.w      #-1,number_folders
         beq.s      main_loop\test_f1_to_f5
         cmp.w      #338,d6
         beq        move\up
         cmp.w      #4434,d6
         beq        move\up\second
         cmp.w      #8530,d6
         beq        move\go_to_top
         cmp.w      #344,d6
         beq        move\down
         cmp.w      #4440,d6
         beq        move\down\second
         cmp.w      #8536,d6
         beq        move\go_to_bottom

main_loop\test_left_and_right
         cmp.w      #337,d6
         beq        switch\right
         cmp.w      #340,d6
         beq        switch\left

main_loop\test_f1_to_f5
         cmp.w      #268,d6
         bcs.s      main_loop\not_f1_to_f5
         cmp.w      #272,d6
         bhi.s      main_loop\not_f1_to_f5
         bra        menu_loop\start

main_loop\not_f1_to_f5

main_loop\test_a_to_z
         cmp.w      #97,d6
         bcs.s      main_loop\not_a_to_z
         cmp.w      #122,d6
         bhi.s      main_loop\not_a_to_z
         bra        move\a_to_z
main_loop\not_a_to_z

main_loop\shortcuts
         bra        test_shortcut

main_loop\exit
         addq.l     #4,a7

_exit
         bsr        uninit_mode
         bsr        unalloc_file_list
         bsr        unalloc_folder_list
         bsr        system\interrupts_on
         jsr        tios::reset_link
         clr.w      tios::kb_vars+$1C
         rts

 include "dialog.asm"

 include "errors.asm"

 include "execute.asm"

 include "file.asm"

 include "init.asm"

 include "inputstr.asm"

 include "keyboard.asm"

 include "menu.asm"

 include "misc.asm"

 include "move.asm"

 include "setup.asm"

 include "system.asm"

 include "vat.asm"

 include "data.asm"

 end


;============================================================================;
;                                  tex.asm                                   ;
;============================================================================;